
/*

NOTE:
See my full writeup at:
http://kelan.io/2015/approachable-functional-thikning-using-protocol-extensions



Intro
=====

This is a writeup of the code from Daniel Steinberg's "Somewhere between
Tomorrowland and Frontierland" talk at NSConf 2015.
https://vimeo.com/channels/nsconf7/124349158

It's an exploration of the the "Battleship" example from the Objc.io book,
"Functional Programming in Swift".

In the book, they first describe an example of a "Object-Oriented approach"
that we might use to solve the problem, and then how it evolves (poorly, to
their point) over time.  They then show how a Functional approach to the
problem might look, and you can see the advantages.

However, they "key concept" that they use (i.e. using a function to represent
something that someone with an Object-Oriented mindset would think to use an
object for), still feels very unintuitive (to me at least).  So, I very much
liked the "intermediate" idea that Daniel Steinberg showed in his talk, which
is to use a protocol that "holds" the function, so it gets the benefits of
composability that the functional approach has, but feels more familiar to
someone with an OO background.


*/
